/************************************************/
/*      TASK00									*/
/*		LED									*/
/*				mirs9803						*/
/************************************************/
#include "mirx68k.h"
#include "hard.h"

#define TIMER_LED 10		/* kdc䃂W[̃^C}[10msec] */
#define TIMER_USS 12		/* gZT䃂W[̃^C}[10msec] */
#define TIMER_SELF 4		/* ȈʒuF*/
#define TIMER_IRS 16		/* ԊO荞݂ȂJEgW[̃^C}[10msec] */
#define TIMER_RE 3			/* [^GR[_f[^ǗW[̃^C}[10msec] */
#define TIMER_PWM 3			/* ovl䃂W[̃^C}[10msec] */
#define TIMER_TOUCH 12		/* ovl䃂W[̃^C}[10msec] */

#define TIMER_JUDGE 5		/* 󋵕͊JnW[̃^C}[10msec] */
#define NUMBER_OF_USS 3	/* 䂷钴gZT̐iőSj */
#define US_DATA 3	/* P|[g̒gZT̋f[^ۗ̕L */
#define US_NOINT 999	/* gZTɊ荞ݐMAĂȂƂ̋f[^ */
#define US_ERR 1000	/* gZTُ̈펞̋f[^ */
#define US_DISP (200/TIMER_LED)	/* fBXvC̒gZTP|[g̕\[10msec] */

#define ABS(x) (-(x<0)+(x>=0))*(x)
/* ABS (Βl)}N
 * x̌^int,float,doubleȂłv(̔)łB
 * This MACRO is programmed by Shingo Suzuki. (Use free) 
 * ver 1.01
 * 쐬 98/11/11
 */
#define PORM(x) (x<0)

/* ݒ胂W[ */
void inzt00(){
	
	sys0(0,0x1011);	/* ^XN̏ݒ */
	
	/* I/O ̏ */
	mmi_init();	/* llh̏(hard.c) */
	irs_init(0);	/* ԊOZT̏(hard.c) */
	re_ts_init();	/* [^GR[_E^b`ZT̏(hard.c) */
	uss_init();	/* gZT̏(hard.c) */
	pwm_init();	/* ovlH̏(hard.c) */
	pwm_data(0,0);	/* \h~ */
	rs_init();	 /*qr|QRQb|[g̏(hard.c) */
	
	/*task1*/
	sys2(1,TIMER_USS,0,0);	/* gZT䃂W[̓o^ */
	sys4(1);	 /*gZT䃂W[̃^C}JEgXgbv */
	/*task2*/
	sys2(2,TIMER_SELF,0,0);	/* Ȉʒu䃂W[̓o^ */
	sys4(2);	 /*Ȉʒu䃂W[̃^C}JEgXgbv */
	/*task3*/
	sys2(3,TIMER_IRS,0,0);	/* ԊOZT䃂W[̓o^ */
	sys4(3);	 /*ԊOZT䃂W[̃^C}JEgXgbv */
	/*task4*/
	sys2(4,TIMER_PWM,1,0);	/* ovl䃂W[̓o^ */
	sys4(4);	/* ovl䃂W[̃^C}JEgXgbv */
	/*task5*/
	sys2(5,TIMER_RE,3,0);	/* [^GR[_f[^ǗW[̓o^ */
	sys4(5);	/* [^GR[_f[^ǗW[̃^C}JEgXgbv */
	/*task6*/
	sys2(6,TIMER_TOUCH,3,0);	/* ^b`ZTǗW[̓o^ */
	sys4(6);	/* ^b`ZTǗW[̃^C}JEgXgbv */
	/*task7*/
	sys2(7,TIMER_JUDGE,2,0);	/* 󋵕͊JnW[̓o^ */
	sys4(7);	/* 󋵕͊JnW[̃^C}JEgXgbv */
	
	/*task0*/
	sys2(0,TIMER_LED,4,0);	/* kdc䃂W[̓o^ */
	sys4(0);	/* kdc䃂W[̃^C}JEgXgbv */
	sys3(0,1);	/* kdc䃂W[̃^C}JEgX^[gAZbg */
	
	/* aȁl̏ */
	sys8(0,1,0);	/*NfBbvXCb`*/
	sys8(0,2,0);
	sys8(0,3,0);	/* NVkdc\f[^̏ */
	sys8(0,4,0);	/* fBXvCkdc\[hiNOj */
	sys8(0,5,0);
	
	led_on(OFF);	/* PFkdc̏iԁE΂̗j(hard.c) */
	
	sys5(0,1,BTN_INT_VCT,0,0);	/* N[h胂W[̓o^iI[gxN^j */
	btn_enable_int();	/* {^XCb`̊荞݂(hard.c) */
	rs_snd("ݒ胂W[0\n"); 
	
}

void nrmt00(int prm1,int prm2){ /* prm1,prm2͖gp */

}

/* kdc䃂W[ */
void timt00(int prm1,int prm2){ /* prm1,prm2͖gp */
	static int	disp_uss=1,sw_data,mmi_7seg,
			delay=US_DISP;
	
	sw_data=dipsw_data();	/* DIPXCb`f[^̎擾 */
	
	switch(sys9(0,4)){	/* fBXvCkdc\[hɂ镪 */
		case 0: /* NO */
			mmi_7seg=sw_data;	/* [^XCb`f[^ */
			if(pow_chk()==0){/* 쓮ndnee */
				mmi_7seg+=1000;
			}
			/*rs_snd("쓮ndON\n");*/
		break;
		case 1:
			mmi_7seg=sys9(0,3);	/* Vkdc\f[^̓ǂݍ */
		break;
		case 2:  /* \ؑ */
			switch(sw_data){
				case 0:/* f[^擾 */
				break;
				case 1: /* gJE^ */
					mmi_7seg=sys9(1,9);
				break;				
				case 2: /* IRS data */
					mmi_7seg=sys9(3,1);
				break;				
				case 3: /* ^b`ZTf[^ */
					mmi_7seg=sys9(6,1);
				break;				
				case 4: /* IRS data */
					mmi_7seg=sys9(3,2);
				break;				
				case 5: /* r_dis */
					mmi_7seg=sys9(5,5);
				break;				
				case 6: /* l_dis */
					mmi_7seg=sys9(5,6);
				break;				
				case 11:  /*gZT1*/
					mmi_7seg=sys9(1,1);
				break;
				
				case 12:  /*gZT2*/ 
					mmi_7seg=sys9(1,2);
				break;
				
				case 13:  /*gZT3*/ 
					mmi_7seg=sys9(1,3);
				break;
				
				case 14:  /*gZT4*/
					mmi_7seg=sys9(1,4);
				break;
				case 15:  /**/
					mmi_7seg=sys9(8,2);
				break;
				
			}
		break;
	}
	led_set_all(mmi_7seg);	/* fBXvCkdcւ̕\(hard.c) */

}

/* N[h胂W[ */
interrupt void intt00(){

	int	sw_data,
		/* W[N󋵁iOFsgpCPFgpj */
		ir_check=0,	/* ԊO荞݂ȂJEgW[ */
		self_control=0,/*Ȉʒu䃂W[*/
		re_check=0,	/* [^GR[_f[^ǗW[ */
		ts_check=0,/*^b`ZTǗ*/
		us_receive=0,	/* gMW[ */
		us_send=0,	/* gZT䃂W[iOFsgpCPFS|[gCQFeXgj */
		pwm_control=0,	/* ovl䃂W[ */
		main_control=0,	/* 󋵕͊JnW[ */
		disp_mode=1,	/* fBXvCkdc\[hiPFf[^擾CQFXCb`؂ւCRFg؂ւj */
		main_con=0;
	
	btn_disable_int();	/* {^XCb`̊荞݂s(hard.c) */
	
	led_on(GREEN|RED);	/* PFkdc̓_iԁE΂̗j(hard.c) */
	
	rs_snd("N[h胂W[s\n\n\n"); 
	
	sw_data=dipsw_data();	/* [^XCb`f[^̎擾(hard.c) */
	sys8(0,1,sw_data);	/* NfBbvXCb`̏ */
	
	switch(sw_data){	/* NfBbvXCb`ɂ镪 */
		case 0: /* NȂ */
		rs_snd("N~\n"); 
			btn_enable_int();	/* {^XCb`̊荞݂(hard.c) */
			disp_mode=0;	/* fBXvCkdc\[hFNO */
		break;
		
		case 1: /* g */
			disp_mode=2;
			us_receive=1;/*task1*/
			us_send=1;/*task1*/
			break;
			
		case 2: /* ԊOZT */
			disp_mode=2;
			ir_check=1;/*task3*/
			break;
			
		case 3: /* ^b`ZT*/
			disp_mode=2;
			ts_check=1;/*task6*/
			break;
			
		case 4: /* pwm */
			disp_mode=2;
			pwm_control=1;/*task4*/
			main_con=1;/*task8*/
		break;
		case 5: /* re */
			disp_mode=2;
			re_check=1;/*task5*/
		break;
		case 6: /*  */
			disp_mode=2;
			pwm_control=1;/*task4*/
			re_check=1;/*task5*/
			main_control=1;/*task7*/
		break;

		default:	/* eXg샂[hŋN */
			rs_snd("eXg샂[hŋN܂B\n"); 
			
			disp_mode=2;
			self_control=1;
			ir_check=1;
			re_check=1;
			ts_check=1;
			us_receive=1;
			us_send=1;
			pwm_control=1;
			main_control=1;
		break;
	}

	
	sys8(0,4,disp_mode);	/* fBXvCkdc\[h̏ */
	if(us_send){
		sys3(1,1);/*	gZT䃂W[̃^C}JEgX^[gAZbg */
	}
	if(us_receive){
		sys5(1,0,USS_INT_VCT,0,0);/*	gf[^ǗW[̓o^iI[gxN^j */
		if(ir_check==0){
			sys11(1);	/*荞݃}XN̉igZTAԊOZTŗpj */
		}
	}
	if(self_control){/*Ȉʒu䃂W[̓o^*/
		sys3(2,1);
	}
	if(ir_check){
		sys3(3,1);	 /*ԊO荞݂ȂJEgW[̃^C}JEgX^[gAZbg */
		sys5(3,0,IRS_INT_VCT,0,0);	/*ԊOf[^ǗW[̓o^iI[gxN^j */
		irs_enable_int();	/*ԊOZT̊荞݂ */ 
		sys11(1);	/*荞݃}XN̉igZTAԊOZTŗp j */
	}
	if(pwm_control){
		sys3(4,1);	/* ovl䃂W[̃^C}JEgX^[gAZbg */
	}
	if(re_check){
		re_counter_reset();	/* [^GR[_JEgZbg */
		sys3(5,1);	/* [^GR[_f[^ǗW[̃^C}JEgX^[gAZbg */
	}
	if(ts_check){
		sys3(6,1);	/* [^GR[_f[^ǗW[̃^C}JEgX^[gAZbg */
	}
	if(main_control){
		sys3(7,1);	/* 󋵕͊JnW[̃^C}JEgX^[gAZbg */
		sys8(7,4,2);
	}
	if(main_con){
		sys3(7,1);	/* 󋵕͊JnW[̃^C}JEgX^[gAZbg */
		sys8(7,4,5);
	}
	
	
	led_on(OFF);	/* PFkdc̏iԁE΂̗j(hard.c) */
	sys8(0,3,9803); /* NVkdc\f[^̏ */
	
	sys8(0,5,sw_data%6);
}
